K <- function(x)
{
        y <- 1 - x^2
        y[y < 0] <- 0
	y
}



fig65 <- function(post=F)
{
#Let $K$ be the kernel and its deivatives function.
###  Mirror imaging the figure of Fan and Gijbels (1996)
###  change the range from 0.45 -- 0.75 to [0,1]

X <- c( 0.4500, 0.4610, 0.4728, 0.4748, 0.4821, 0.4928, 0.4959, 0.5000,
	0.5021, 0.5048, 0.5059, 0.5100, 0.5121, 0.5128, 0.5138, 0.5148,
	0.5190, 0.5200, 0.5279, 0.5290, 0.5338, 0.5400, 0.5421, 0.5479,
	0.5521, 0.5528, 0.5548, 0.5621, 0.5648, 0.5769, 0.5869, 0.5900,
	0.5938, 0.6048, 0.6100, 0.6238, 0.6338, 0.6359, 0.6500, 0.6610,
	0.6679, 0.6690, 0.6769, 0.6821, 0.6859, 0.6938, 0.7100, 0.7200,
	0.7238, 0.7500)

Y <- c(-2.0758, -1.4734, -0.8998, -0.8098, -0.4980, -0.0869,  0.0225, 
	0.1606,  0.2286,  0.3133,  0.3470,  0.4681,  0.5276,  0.5470,
	0.5745,  0.6015,  0.7111,  0.7362,  0.9224,  0.9466,  1.0476,
	1.1672,  1.2051,  1.3031,  1.3683,  1.3787,  1.4077,  1.5052,
	1.5380,  1.6657,  1.7496,  1.7720,  1.7975,  1.8593,  1.8830,
 	1.9315,  1.9559,  1.9600,  1.9808,  1.9903,  1.9941,  1.9946, 
	1.9972,  1.9983,  1.9989,  1.9996,  2.0000,  2.0000,  2.0000,
	1.9994)
X <- X[-1]
Y <- Y[-1]

if(post)
  {#ps.options (colors=ps.colors.rgb[c("blue", "magenta", "cyan",
   #"green", "MediumBlue", "red", "black", "yellow", "blue"),])
    postscript("Fig65.ps", width=4.4, height=5, horizontal=F, pointsize=8)
  }
 else {if(dev.cur()==1) motif(); par(ask=T)}

  par(mfrow = c(2, 1),mar=c(5,3,3,1)+0.1)
  par(mex=0.5,csi=0.11)

X <- (X-0.45)/0.3
Y <- -2*Y


	h <- 0.3 	#bandwidth
	x <- 0.5

     plot(X, Y, pch = "*", xlab="(a)", ylab="", type="n", ylim=c(-4,4));
     polygon(c(0, 0.35, 0.35, 0, 0), -2* c(0, 0, -2, -2, 0), col=2)
     polygon(c(0.20, 0.8, 0.8, 0.2, 0.2), -2* c(2, 2, -0, -0, 2), col=4)
     abline(0, 0)
     points(X,Y, pch=18)
     legend(0.6,3.8,c("True value","Estimated value"), lty=c(1,3))	
     title("Nadaraya-Watson estimator", "")
     for(ipoint in 0:1)
      { x <- 0.05 + ipoint*0.45
	if(ipoint == 0) factor <- 14
	else factor <- 40
	X1 <- X[X >= x - h]
	X1 <- X1[X1 <= x + h]	#effective design points 
	Kvec <- K((X - x)/h)
	true.m <- -2*50 * (exp(-16 * ( 0.45 + x*0.3 - 0.72)^4) - 0.96)
	#Watson-Nadaraya Kernel weights 
	s0 <- sum(Kvec)
	Kvec0 <- K((X1 - x)/h)
	i1 <- length((1:50)[X < x - h])	#i1+1 = first index of effective data 
	#s1 <- sum(Kvec1)
	weight1 <- Kvec0/s0
	estimated.NW <- sum(weight1 * Y[(i1 + 1):(length(X1) + i1)])
						     #fitted estimate
	Y1 <- true.m + 0 * (X1 - x)
	Y2 <- estimated.NW + 0 * (X1 - x)	#a local line
	lines(X1, factor*weight1)
	points(X1, factor*weight1, pch = 16+ipoint)
	lines(X1, Y1, lwd=2)
	lines(X1, Y2, lty = 3)
	lines(c(x, x), c(0, -2*(-1)^{ipoint+1}*max(Y)))
	#box(3)
      }


#Starting computing local linear fit
     plot(X, Y, pch = "*", xlab="(b)", ylab="", type="n", ylim=c(-4,4));
     title("Local linear regression estimator", "")
     polygon(c(0, 0.35, 0.35, 0, 0), -2* c(0, 0, -2, -2, 0), col=2)
     polygon(c(0.20, 0.8, 0.8, 0.2, 0.2), -2* c(2, 2, -0, -0, 2), col=4)
     abline(0, 0)
     points(X,Y, pch=18)
     legend(0.6,3.8,c("True value","Estimated value"), lty=c(1,3))	
  for(ipoint in 0:1)
       { x <- 0.05 + ipoint*0.45
	 if(ipoint == 0) factor <- 14 
         else factor <- 40

         X1 <- X[X >= x - h]
	 X1 <- X1[X1 <= x + h]   #effective design points
	 true.m <- -2*50 * (exp(-16 * ( 0.45 + x*0.3 - 0.72)^4) - 0.96)


	 i1 <- length((1:50)[X < x - h])
         Kvec <- K((X - x)/h)
	s0 <- sum(Kvec)
	s1 <- sum((Kvec * (X - x)))
	s2 <- sum((Kvec * (X - x)^2))
        Y1 <- true.m + 0 * (X1 - x)	
	Kvec1 <- K((X1 - x)/h)	#kernel vector for effective design points 
	weight3 <- Kvec1*(s2 - (X1 - x)*s1)/(s2*s0 - s1^2)
        Y2 <- sum(weight3*Y[(i1 + 1):(length(X1) + i1)])    #fitted est
        Y2 <- Y2 + 0 * (X1-x)

        lines(X1, Y1,lwd=2)
	lines(X1, Y2, lty = 3)
	lines(X1, factor*weight3)
	points(X1, factor*weight3, pch = 16+ipoint)
        
	lines(c(x, x), c(0, -2*(-1)^{ipoint+1}* max(Y)))
	#title("Figure 1.3: Local linear weights")	#box(3)
       }

       # plot(X, Y, type="n") 
       # legend(0.45,0.5,c("True value","Estimated value"), lty=c(1,3))

}
